"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
exports.formatFullDate = formatFullDate;
var _dateFns = require("date-fns");
/**
 *
 * @param {string} month
 */

function formatFullDate() {
  let year = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  let month = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  let day = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
  let dateStr = '';
  const monthFull = typeof month === 'number' && month < 10 ? `0${month}` : month.toString();
  const dayNumberFull = typeof day === 'number' && day < 10 ? `0${day}` : day.toString();
  dateStr = `${String(year)}-${monthFull}-${dayNumberFull}`;
  return dateStr;
}
function getWeeks(date) {
  let weekStartsOn = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  const weekDayNotInMonth = {
    dayNumber: '',
    dateNumberFull: '',
    fullDate: ''
  }; // For the first or last week epmtyDays
  // 获取这个月有多少天
  const daysInMonth = (0, _dateFns.getDaysInMonth)(date); // Get the total number of days in the month
  const year = (0, _dateFns.format)(date, 'yyyy');
  const month = (0, _dateFns.format)(date, 'MM');
  const lastday = (0, _dateFns.lastDayOfMonth)(date); // Get the last day of the month
  const firstDay = (0, _dateFns.startOfMonth)(date); // Get the first day of the month
  // Const firstDayInWeek = getDay (firstDay);//The first day belongs to the day of the week
  // What is the first day of the month in the first row?
  const firstDayInWeek = Number((0, _dateFns.format)(firstDay, 'e', {
    weekStartsOn
  }));
  const weeks = [];
  let week = [];
  // add empty days to set first day in correct position
  // for (let s = 1; s < firstDayInWeek; s++) {
  //     week.push(weekDayNotInMonth);
  // }
  // let test = [];
  for (let s = 1; s < firstDayInWeek; s++) {
    const previousDayDate = (0, _dateFns.subDays)(firstDay, firstDayInWeek - s);
    const weekDayNotInMonthFilled = {
      dayNumber: Number((0, _dateFns.format)(previousDayDate, 'd')),
      dayNumberFull: (0, _dateFns.format)(previousDayDate, 'dd'),
      fullDate: (0, _dateFns.format)(previousDayDate, 'yyyy-MM-dd'),
      notInMonth: true
    };
    week.push(weekDayNotInMonth);
  }
  for (let d = 0; d < daysInMonth; d++) {
    const dayNumber = d + 1;
    const dayNumberFull = dayNumber < 10 ? `0${dayNumber}` : dayNumber.toString();
    const fullDate = formatFullDate(year, month, dayNumber);
    week.push({
      dayNumber,
      dayNumberFull,
      fullDate
    });
    if (week.length === 7) {
      weeks.push(week);
      week = [];
    } else if (fullDate === (0, _dateFns.format)(lastday, 'yyyy-MM-dd')) {
      // Last week alone
      weeks.push(week);
      week = [];
    }
  }
  // if (week.length > 0) {
  //     const remainingDays = 7 - week.length;
  //     for (let r = 1; r <= remainingDays; r++) {
  //         const nextDayDate = addDays(lastday, r);
  //         const weekDayNotInMonth = {
  //             dayNumber: Number(format(nextDayDate, 'd')),
  //             dayNumberFull: format(nextDayDate, 'dd'),
  //             fullDate: format(nextDayDate, 'yyyy-MM-dd'),
  //             notInMonth: true,
  //         };
  //         week.push(weekDayNotInMonth);
  //     }
  //     weeks.push(week);
  // }
  // console.log('weeks: ', weeks);
  return weeks;
}
const getMonthTable = (month, weekStartsOn) => {
  const weeks = getWeeks(month, weekStartsOn);
  const monthText = (0, _dateFns.format)(month, 'yyyy-MM');
  return {
    monthText,
    weeks,
    month
  };
};
var _default = getMonthTable;
exports.default = _default;