import BaseFoundation, { DefaultAdapter } from '../base/foundation';
export interface Item {
    [x: string]: any;
    transform?: (value: any, text: string) => string;
    value: any;
    text?: string;
    disabled?: boolean;
}
export interface ScrollItemAdapter<P = Record<string, any>, S = Record<string, any>, I = Item> extends DefaultAdapter<P, S> {
    setPrependCount: (prependCount: number) => void;
    setAppendCount: (appendCount: number) => void;
    setSelectedNode: (el: HTMLElement) => void;
    isDisabledIndex: (i: number) => boolean;
    notifySelectItem: (data: I) => void;
    notifySelectEndItem: (data: I) => void;
    scrollToCenter: (selectedNode: Element, scrollWrapper?: Element, duration?: number) => void;
    setRangeEnd: (rangeHourEnd: any) => void;
    setHoverHourTimer: (hoverHour: any) => void;
    setRangeStart: (rangeHourStart: any) => void;
    setHourList: (list: any) => void;
    setMinutesList: (list: any) => void;
    setNeedReselect: (needReselect: any) => void;
    notifyEndHour: (index: any) => void;
    notifyStartHour: (index: any) => void;
    setHoverMinuteTimer: (hoverHour: any) => void;
    setRangeMinuteStart: (index: any) => void;
    setRangeMinuteEnd: (index: any) => void;
    setMinutesNeedReselect: (index: any) => void;
    notifyMinutesStart: (index: any) => void;
    notifyMinutesEnd: (index: any) => void;
}
export default class ItemTimerFoundation<P = Record<string, any>, S = Record<string, any>, I = Item> extends BaseFoundation<ScrollItemAdapter<P, S, I>, P, S> {
    _cachedSelectedNode: HTMLElement;
    constructor(adapter: any);
    setHoverHourHandle(index: any): void;
    formatOption(option: number): {
        value: string;
    };
    initData(): void;
    initMinutesData(): void;
    setRange(index: any): void;
    setHoverMinuteHandle(index: any): void;
    setMinutesRange(index: any): void;
}
