import BaseFoundation from '../base/foundation';
export default class ItemTimerFoundation extends BaseFoundation {
  constructor(adapter) {
    super(Object.assign({}, adapter));
    this._cachedSelectedNode = null;
  }
  setHoverHourHandle(index) {
    this._adapter.setHoverHourTimer(index);
  }
  formatOption(option) {
    let value = `${option}`;
    if (option < 10) {
      value = `0${option}`;
    }
    return {
      value
    };
  }
  initData() {
    let hourOptionsAdj = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23];
    this._adapter.setHourList(hourOptionsAdj.map(option => this.formatOption(option)));
  }
  initMinutesData() {
    let hourOptionsAdj = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59];
    this._adapter.setMinutesList(hourOptionsAdj.map(option => this.formatOption(option)));
  }
  setRange(index) {
    const {
      hoverHour,
      rangeHourStart,
      rangeHourEnd,
      needReselect
    } = this.getStates();
    if (needReselect) {
      this._adapter.setRangeStart(index);
      this._adapter.setRangeEnd(index);
      this._adapter.setNeedReselect(false);
      this._adapter.notifyStartHour(index);
      // this._adapter.notifyEndHour(index);
    } else {
      this._adapter.setNeedReselect(true);
      this._adapter.setRangeEnd(index);
      this._adapter.notifyEndHour(index);
    }
    console.log(rangeHourStart, rangeHourEnd, 'RAngeSTart');
  }
  setHoverMinuteHandle(index) {
    this._adapter.setHoverMinuteTimer(index);
  }
  setMinutesRange(index) {
    const {
      hoverHour,
      rangeHourStart,
      rangeHourEnd,
      needReselect
    } = this.getStates();
    console.log(hoverHour, needReselect, 'NeeDReslected');
    if (needReselect) {
      this._adapter.setRangeMinuteStart(index);
      this._adapter.setRangeMinuteEnd(index);
      this._adapter.setMinutesNeedReselect(false);
      this._adapter.notifyMinutesStart(index);
    } else {
      this._adapter.setMinutesNeedReselect(true);
      this._adapter.setRangeMinuteEnd(index);
      this._adapter.notifyMinutesEnd(index);
    }
  }
}